%define _build_arch x86_64
%define _boot_flavor standard
%define prefix /usr

# prevent RPM from stripping files
%define __spec_install_post /usr/lib/rpm/brp-compress

# prevent RPM files to be changed by prelink
%{?__prelink_undo_cmd:%undefine __prelink_undo_cmd}

Summary:	Software that automates Linux installs, software distribution, and production deployment.
Name:		systemimager
Version:	4.0.2
Release:	1.ru
License:	GPL
Group:		Applications/System
Source0: 	%{name}-install.tar.gz
BuildRoot: 	%{_tmppath}/%{name}-root
BuildArch: 	noarch
URL:		http://wiki.systemimager.org/
Requires:	rsync >= 2.4.6, syslinux >= 1.48, libappconfig-perl, dosfstools, /usr/bin/perl
AutoReq: 	no

%description
SystemImager is software that automates Linux installs, software
distribution, and production deployment.  SystemImager makes it easy to
do installs, software distribution, content or data distribution,
configuration changes, and operating system updates to your network of
Linux machines. You can even update from one Linux release version to
another!  It can also be used to ensure safe production deployments.
By saving your current production image before updating to your new
production image, you have a highly reliable contingency mechanism.  If
the new production enviroment is found to be flawed, simply roll-back
to the last production image with a simple update command!  Some
typical environments include: Internet server farms, database server
farms, high performance clusters, computer labs, and corporate desktop
environments.

%package server
Summary:	Software that automates Linux installs, software distribution, and production deployment.
Group:		Applications/System
Requires:	rsync >= 2.4.6, systemimager-common = %{version}, perl-AppConfig, dosfstools, /sbin/chkconfig, perl, perl(XML::Simple) >= 2.14, python, mkisofs

%description server
SystemImager is software that automates Linux installs, software 
distribution, and production deployment.  SystemImager makes it easy to
do installs, software distribution, content or data distribution, 
configuration changes, and operating system updates to your network of 
Linux machines. You can even update from one Linux release version to 
another!  It can also be used to ensure safe production deployments.  
By saving your current production image before updating to your new 
production image, you have a highly reliable contingency mechanism.  If
the new production enviroment is found to be flawed, simply roll-back 
to the last production image with a simple update command!  Some 
typical environments include: Internet server farms, database server 
farms, high performance clusters, computer labs, and corporate desktop
environments.

The server package contains those files needed to run a SystemImager
server.

%package common
Summary:	Software that automates Linux installs, software distribution, and production deployment.
Group:		Applications/System
Requires:	perl, systemconfigurator >= 2.2.11

%description common
SystemImager is software that automates Linux installs, software 
distribution, and production deployment.  SystemImager makes it easy to
do installs, software distribution, content or data distribution, 
configuration changes, and operating system updates to your network of 
Linux machines. You can even update from one Linux release version to 
another!  It can also be used to ensure safe production deployments.  
By saving your current production image before updating to your new 
production image, you have a highly reliable contingency mechanism.  If
the new production enviroment is found to be flawed, simply roll-back 
to the last production image with a simple update command!  Some 
typical environments include: Internet server farms, database server 
farms, high performance clusters, computer labs, and corporate desktop
environments.

The common package contains files common to SystemImager clients 
and servers.

%package client
Summary:	Software that automates Linux installs, software distribution, and production deployment.
Group:		Applications/System
Requires:	systemimager-common = %{version}, systemconfigurator >= 2.2.11, perl-AppConfig, rsync >= 2.4.6, perl

%description client
SystemImager is software that automates Linux installs, software
distribution, and production deployment.  SystemImager makes it easy to
do installs, software distribution, content or data distribution,
configuration changes, and operating system updates to your network of
Linux machines. You can even update from one Linux release version to
another!  It can also be used to ensure safe production deployments.
By saving your current production image before updating to your new
production image, you have a highly reliable contingency mechanism.  If
the new production enviroment is found to be flawed, simply roll-back
to the last production image with a simple update command!  Some
typical environments include: Internet server farms, database server
farms, high performance clusters, computer labs, and corporate desktop
environments.

The client package contains the files needed on a machine for it to
be imaged by a SystemImager server.

%package %{_build_arch}boot-%{_boot_flavor}
Summary:	Software that automates Linux installs, software distribution, and production deployment.
Group:		Applications/System
Obsoletes:	systemimager-%{_build_arch}boot
Requires:	systemimager-server >= %{version}

%description %{_build_arch}boot-%{_boot_flavor}
SystemImager is software that automates Linux installs, software 
distribution, and production deployment.  SystemImager makes it easy to
do installs, software distribution, content or data distribution, 
configuration changes, and operating system updates to your network of 
Linux machines. You can even update from one Linux release version to 
another!  It can also be used to ensure safe production deployments.  
By saving your current production image before updating to your new 
production image, you have a highly reliable contingency mechanism.  If
the new production enviroment is found to be flawed, simply roll-back 
to the last production image with a simple update command!  Some 
typical environments include: Internet server farms, database server 
farms, high performance clusters, computer labs, and corporate desktop
environments.

The %{_build_arch}boot package provides specific kernel, ramdisk, and fs utilities
to boot and install %{_build_arch} Linux machines during the SystemImager autoinstall
process.

%package %{_build_arch}initrd_template
Summary:	Software that automates Linux installs, software distribution, and production deployment.
Group:		Applications/System

%description %{_build_arch}initrd_template
SystemImager is software that automates Linux installs, software
distribution, and production deployment.  SystemImager makes it easy to
do installs, software distribution, content or data distribution,
configuration changes, and operating system updates to your network of
Linux machines. You can even update from one Linux release version to
another!  It can also be used to ensure safe production deployments.
By saving your current production image before updating to your new
production image, you have a highly reliable contingency mechanism.  If
the new production enviroment is found to be flawed, simply roll-back
to the last production image with a simple update command!  Some
typical environments include: Internet server farms, database server
farms, high performance clusters, computer labs, and corporate desktop
environments.

The %{_build_arch}initrd_template package provides initrd template files for creating custom
ramdisk that works with a specific kernel by using UYOK (Use Your Own Kernel).  The custom
ramdisk can then be used to boot and install %{_build_arch} Linux machines during the
SystemImager autoinstall process.

%prep

%build

%install
mkdir -p %{buildroot}
cd %{buildroot}
tar xzf %{SOURCE0}

%clean
rm -rf %{buildroot}


%pre server
# /etc/systemimager/rsyncd.conf is now generated from stubs stored
# in /etc/systemimager/rsync_stubs.  if upgrading from an early
# version, we need to create stub files for all image entries
if [ -f /etc/systemimager/rsyncd.conf -a \
    ! -d /etc/systemimager/rsync_stubs ]; then
    echo "You appear to be upgrading from a pre-rsync stubs release."
    echo "/etc/systemimager/rsyncd.conf is now auto-generated from stub"
    echo "files stored in /etc/systemimager/rsync_stubs."
    echo "Backing up /etc/systemimager/rsyncd.conf to:"
    echo -n "  /etc/systemimager/rsyncd.conf-before-rsync-stubs... "
    mv /etc/systemimager/rsyncd.conf \
      /etc/systemimager/rsyncd.conf-before-rsync-stubs

    ## leave an extra copy around so the postinst knows to make stub files from it
    cp /etc/systemimager/rsyncd.conf-before-rsync-stubs \
      /etc/systemimager/rsyncd.conf-before-rsync-stubs.tmp
    echo "done."
fi    


%post server
# First we check for rsync service under xinetd and get rid of it
# also note the use of DURING_INSTALL, which is used to
# support using this package in Image building without affecting
# processes running on the parrent
if [[ -a /etc/xinetd.d/rsync ]]; then
    mv /etc/xinetd.d/rsync /etc/xinetd.d/rsync.presis~
    `pidof xinetd > /dev/null`
    if [[ $? == 0 ]]; then
        if [ -z $DURING_INSTALL ]; then
            /etc/init.d/xinetd restart
        fi
    fi
fi

# If we are upgrading from a pre-rsync-stubs release, the preinst script
# will have left behind a copy of the old rsyncd.conf file.  we need to parse
# it and make stubs files for each image.

# This assumes that this file has been managed by systemimager, and
# that there is nothing besides images entries that need to be carried
# forward.

in_image_section=0
current_image=""
if [ -f /etc/systemimager/rsyncd.conf-before-rsync-stubs.tmp ]; then
    echo "Migrating image entries from existing /etc/systemimager/rsyncd.conf to"
    echo "individual files in the /etc/systemimager/rsync_stubs/ directory..."
    while read line; do
	## Ignore all lines until we get to the image section
	if [ $in_image_section -eq 0 ]; then
	    echo $line | grep -q "^# only image entries below this line"
	    if [ $? -eq 0 ]; then
		in_image_section=1
	    fi
	else
	    echo $line | grep -q "^\[.*]$"
	    if [ $? -eq 0 ]; then
		current_image=$(echo $line | sed 's/^\[//' | sed 's/\]$//')
		echo -e "\tMigrating entry for $current_image"
		if [ -e "/etc/systemimager/rsync_stubs/40$current_image" ]; then
		    echo -e "\t/etc/systemimager/rsync_stubs/40$current_image already exists."
		    echo -e "\tI'm not going to overwrite it with the value from"
		    echo -e "\t/etc/systemimager/rsyncd.conf-before-rsync-stubs.tmp"
		    current_image=""
		fi
	    fi
	    if [ "$current_image" != "" ]; then
		echo "$line" >> /etc/systemimager/rsync_stubs/40$current_image
	    fi
	fi
    done < /etc/systemimager/rsyncd.conf-before-rsync-stubs.tmp
    rm -f /etc/systemimager/rsyncd.conf-before-rsync-stubs.tmp
    echo "Migration complete - please make sure to migrate any configuration you have"
    echo "    made in /etc/systemimager/rsyncd.conf outside of the image section."
fi
## END make stubs from pre-stub /etc/systemimager/rsyncd.conf file

/usr/sbin/si_mkrsyncd_conf

if [[ -a /usr/lib/lsb/install_initd ]]; then
    /usr/lib/lsb/install_initd /etc/init.d/systemimager-server-rsyncd
    /usr/lib/lsb/install_initd /etc/init.d/systemimager-server-netbootmond
    /usr/lib/lsb/install_initd /etc/init.d/systemimager-server-monitord
fi

if [[ -a /sbin/chkconfig ]]; then
    /sbin/chkconfig --add systemimager-server-rsyncd
    /sbin/chkconfig systemimager-server-rsyncd off
    /sbin/chkconfig --add systemimager-server-netbootmond
    /sbin/chkconfig systemimager-server-netbootmond off
    /sbin/chkconfig --add systemimager-server-monitord
    /sbin/chkconfig systemimager-server-monitord off
fi

%preun server

if [ $1 = 0 ]; then
	/etc/init.d/systemimager-server-rsyncd stop
	/etc/init.d/systemimager-server-netbootmond stop
	/etc/init.d/systemimager-server-monitord stop

	if [[ -a /usr/lib/lsb/remove_initd ]]; then
	    /usr/lib/lsb/remove_initd /etc/init.d/systemimager-server-rsyncd
	    /usr/lib/lsb/remove_initd /etc/init.d/systemimager-server-netbootmond
	    /usr/lib/lsb/remove_initd /etc/init.d/systemimager-server-monitord
	fi

	if [[ -a /sbin/chkconfig ]]; then
	    /sbin/chkconfig --del systemimager-server-rsyncd
	    /sbin/chkconfig --del systemimager-server-netbootmond
	    /sbin/chkconfig --del systemimager-server-monitord
	fi

	if [[ -a /etc/xinetd.d/rsync.presis~ ]]; then
	    mv /etc/xinetd.d/rsync.presis~ /etc/xinetd.d/rsync
	    `pidof xinetd > /dev/null`
	    if [[ $? == 0 ]]; then
	        /etc/init.d/xinetd restart
	    fi
	fi
else
	echo
	echo "WARNING: this seems to be an upgrade!"
	echo
	echo "Remember that this operation does not touch the following objects:"
	echo "  - master, pre-install, post-install scripts"
	echo "  - images"
	echo "  - overrides"
	echo

	# This is an upgrade: restart the daemons.
	echo "Restarting services..."
	(/etc/init.d/systemimager-server-rsyncd status >/dev/null 2>&1 && \
		/etc/init.d/systemimager-server-rsyncd restart) || true
	(/etc/init.d/systemimager-server-netbootmond status >/dev/null 2>&1 && \
		/etc/init.d/systemimager-server-netbootmond restart) || true
	(/etc/init.d/systemimager-server-monitord status >/dev/null 2>&1 && \
		/etc/init.d/systemimager-server-monitord restart) || true
fi

%files common
%defattr(-, root, root)
%prefix/bin/si_lsimage
%prefix/share/man/man8/si_lsimage*
%prefix/share/man/man5/autoinstall*
%dir %prefix/lib/systemimager
%prefix/lib/systemimager/perl/SystemImager/Common.pm
%prefix/lib/systemimager/perl/SystemImager/Config.pm
%prefix/lib/systemimager/perl/SystemImager/Options.pm
%prefix/lib/systemimager/perl/SystemImager/UseYourOwnKernel.pm
%dir /etc/systemimager
%config /etc/systemimager/UYOK.modules_to_exclude
%config /etc/systemimager/UYOK.modules_to_include

%files server
%defattr(-, root, root)
%doc %{_docdir}/systemimager-server-%{version}/*
%dir /var/lock/systemimager
%dir /var/log/systemimager
%dir /var/lib/systemimager
%dir /var/lib/systemimager/images
%dir /var/lib/systemimager/scripts
%dir /var/lib/systemimager/scripts/pre-install
%dir /var/lib/systemimager/scripts/post-install
%dir /var/lib/systemimager/overrides
/var/lib/systemimager/overrides/README
%dir /etc/systemimager
%dir %prefix/share/systemimager
%dir %prefix/share/systemimager/icons
%config /etc/systemimager/pxelinux.cfg/*
%config /etc/systemimager/kboot.cfg/*
%config /etc/systemimager/autoinstallscript.template
%config(noreplace) /etc/systemimager/rsync_stubs/*
%config(noreplace) /etc/systemimager/systemimager.conf
%config(noreplace) /etc/systemimager/cluster.xml
%config(noreplace) /etc/systemimager/getimage.exclude
/etc/init.d/systemimager-server-rsyncd
/etc/init.d/systemimager-server-netboot*
/etc/init.d/systemimager-server-monitord
/var/lib/systemimager/images/*
/var/lib/systemimager/scripts/post-install/*
/var/lib/systemimager/scripts/pre-install/*
%prefix/sbin/si_addclients
%prefix/sbin/si_cpimage
%prefix/sbin/si_getimage
%prefix/sbin/si_mk*
%prefix/sbin/si_mvimage
%prefix/sbin/si_netbootmond
%prefix/sbin/si_pushupdate
%prefix/sbin/si_pushinstall
%prefix/sbin/si_rmimage
%prefix/sbin/si_monitor
%prefix/sbin/si_monitortk
%prefix/bin/si_clusterconfig
%prefix/bin/si_mk*
%prefix/bin/si_psh
%prefix/bin/si_pcp
%prefix/bin/si_pushoverrides
%prefix/lib/systemimager/perl/SystemImager/Server.pm
%prefix/lib/systemimager/perl/SystemImager/Config.pm
%prefix/lib/systemimager/perl/SystemImager/HostRange.pm
%prefix/lib/systemimager/perl/confedit
%prefix/lib/systemimager/perl/BootMedia/*
%prefix/share/man/man5/systemimager*
%prefix/share/man/man8/si_*
%prefix/share/systemimager/icons/*

%files client
%defattr(-, root, root)
%doc %{_docdir}/systemimager-client-%{version}/*
%dir /etc/systemimager
%config /etc/systemimager/updateclient.local.exclude
%config /etc/systemimager/client.conf
%prefix/sbin/si_updateclient
%prefix/sbin/si_prepareclient
%prefix/share/man/man8/si_updateclient*
%prefix/share/man/man8/si_prepareclient*
%prefix/lib/systemimager/perl/SystemImager/Client.pm

%files %{_build_arch}boot-%{_boot_flavor}
%defattr(-, root, root)
%dir %prefix/share/systemimager/boot/%{_build_arch}
%dir %prefix/share/systemimager/boot/%{_build_arch}/standard
%prefix/share/systemimager/boot/%{_build_arch}/standard/boel_binaries.tar.gz
%prefix/share/systemimager/boot/%{_build_arch}/standard/config
%prefix/share/systemimager/boot/%{_build_arch}/standard/initrd.img
%prefix/share/systemimager/boot/%{_build_arch}/standard/kernel

%files %{_build_arch}initrd_template
%defattr(-, root, root)
%dir %prefix/share/systemimager/boot/%{_build_arch}/standard/initrd_template
%prefix/share/systemimager/boot/%{_build_arch}/standard/initrd_template/*

%changelog
* Fri Apr 10 2009 Brian Schubert <schubert@nbcs.rutgers.edu> - 4.0.2-1.ru
- Bittorrent and Flamethrower components not included

